function [xwt,xtd,E,F] = xplsa(counts,T,epsilon,td,initwt)

% counts = bow_sequences

W = size(counts,1);
tot  = sum(counts(:));

if nargin == 4
    xwt = normalize( rand(W,T), 1);
else
    xwt = initwt;
end
xtd = td;

done = 0;
iter = 1;

E = sum( counts.*log(xwt*xtd  +eps) ,1);
F = sum( E ) / tot;

while ~done; iter = iter+ 1;
    
    
    xwt = normalize(xwt .* ( ( counts ./ (xwt * xtd + eps ) ) * xtd' ), 1);
    
    
    E = sum( counts.*log( xwt*xtd  +eps) ,1);
    F_new = sum( E ) / tot; F =  [F F_new];
    
    rel_ch = (F(iter) - F(iter-1))/abs(F(iter-1)); if rel_ch< epsilon && (iter> 5 ); done=1;end
    
end